Components.utils.import("resource://modules/kclobserver.jsm");
Components.utils.import("resource://gre/modules/ctypes.jsm");

function debugprint(str){
    var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].
    getService(Components.interfaces.nsIConsoleService);
    aConsoleService.logStringMessage(str);
}

var StatusBarTimer;
var StatusBarTimer2;
var StatusBarMode;
var hw_prefs;
var hw_Branch;
var bundle;

var KclInsp = {

    init: function(){
        KclHttpObserver.init();
        KclHttpObserver.addCallback( KclInspCallback );
        StatusBarMode=0;
        StatusBarTimer= setInterval(function(){UpdateStatusBar();},1000);
        StatusBarTimer2= setInterval(function(){UpdateStatusBarMode();},5000);

    bundle= document.getElementById("kclinsp-bundle");

    hw_prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    hw_Branch=hw_prefs.getBranch("extensions.kclinsp.");

    },

    destroy: function(){
        KclHttpObserver.removeCallback( KclInspCallback );
        KclHttpObserver.destroy();
        clearInterval(StatusBarTimer);
        clearInterval(StatusBarTimer2);
    }

}

const Cc = Components.classes;
const Ci = Components.interfaces;

const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
const HTML_NS= "http://www.w3.org/1999/xhtml";


function getQueryString(str){
    let tstr=str.split("&");
    var rs=[];
    for(let i in tstr){
        let rst=tstr[i].split("=");
        rs[decodeURI(rst[0])]=decodeURI(rst[1]);
    }
    return rs;
}

function KclInspCallback(request,str,rstr){

//try{
    let url = request.name;

    str = str.substring( str.indexOf('svdata=')+7 );
    var data = JSON.parse(str);

    rstr=rstr.substring(rstr.indexOf("\r\n\r\n")+4);
    var rdata = getQueryString(rstr);


    if( url.match(/kcsapi\/api_get_master\/ship$/) ){
        KclInfo.gMasterShip = data.api_data;
        KclInfo.gMasterShipStr = str;

    }else if( url.match(/kcsapi\/api_req_kousyou\/createitem$/) ){
        if(hw_Branch.getBoolPref("createitemlog")){
            let ritem = data.api_data.api_slotitem_id;
            if(typeof ritem !== "undefined"){
                ritem = KclInfo.gMasterItemList[parseInt(ritem)-1].api_name;
            }
            msShip = SearchMasterShip(KclInfo.gMemberFleet[0].api_ship[0]);
            memShip = SearchMemberShip(KclInfo.gMemberFleet[0].api_ship[0]);
            UpdateSortieLog(GetDateTime() + "[" + KclInfo.gMemberBasic.api_level + "]" + "[" + msShip.api_name + ":" + memShip.api_lv + "]" +rdata.api_item1 + "/" + rdata.api_item2 + "/" + rdata.api_item3 + "/" + rdata.api_item4 + ":" + ritem + "/" + data.api_data.api_fdata);
        }
    }else if( url.match(/kcsapi\/api_get_member\/deck$/) ){
        KclInfo.gMemberFleet = data.api_data;
        UpdateFleetList();

    }else if( url.match(/kcsapi\/api_get_member\/ship2$/) ){
        KclInfo.gMemberShip = data.api_data;
        KclInfo.gMemberShipStr = str;
        KclInfo.gMemberFleet = data.api_data_deck;
        UpdateFleetList();
        initShipTree();
        UpdateBaseInfo();
        UpdateItemEquipList();
        UpdateItemList();
        initItemTree();

    }else if( url.match(/kcsapi\/api_get_member\/ship3$/) ){
        KclInfo.gMemberShip = data.api_data.api_ship_data;
        KclInfo.gMemberShipStr = str;
        KclInfo.gMemberFleet = data.api_data.api_deck_data;
        UpdateFleetList();
        initShipTree();
        UpdateBaseInfo();
        UpdateItemEquipList();
        UpdateItemList();
        initItemTree();

    }else if( url.match(/kcsapi\/api_get_member\/ship$/) ){
        KclInfo.gMemberShip = data.api_data;
        KclInfo.gMemberShipStr = str;

    }else if( url.match(/kcsapi\/api_get_member\/questlist$/) ){
        let aRec = KclInfo.gQuestList.api_record;
        KclInfo.gQuestList = data.api_data;
        KclInfo.gQuestList.api_record = aRec;
        UpdateQuestList();
        initQuestTree();
        KclInfo.gQuestList.api_record = false;

    }else if( url.match(/kcsapi\/api_get_member\/record$/) ){
        KclInfo.gQuestList.api_record = true;

    }else if( url.match(/kcsapi\/api_get_member\/slotitem$/) ){
        KclInfo.gMemberItemList = data.api_data;
        KclInfo.gMemberItemStr = str;
        UpdateBaseInfo();
        UpdateItemList();
        initItemTree();

    }else if( url.match(/kcsapi\/api_get_master\/slotitem$/) ){
        KclInfo.gMasterItemList = data.api_data;

    }else if( url.match(/kcsapi\/api_get_member\/basic$/) ){
        KclInfo.gMemberBasic = data.api_data;
        UpdateBaseInfo();

    }else if( url.match(/kcsapi\/api_get_member\/ndock$/) ){
        KclInfo.gMemberNDock = data.api_data;

    }else if( url.match(/kcsapi\/api_get_member\/kdock$/) ){
        KclInfo.gMemberKDock = data.api_data;

    }else if( url.match(/kcsapi\/api_req_map\/start$/) ){
        KclInfo.gMapRequest = data.api_data;
        KclInfo.gMapRequest.Direction = "Start:"
        UpdateMapInfoLog();
        UpdateProgressLog();

    }else if( url.match(/kcsapi\/api_req_map\/next$/) ){
        KclInfo.gMapRequest = data.api_data;
        KclInfo.gMapRequest.Direction = "Next:"
        UpdateProgressLog();

    }else if( url.match(/kcsapi\/api_req_sortie\/battle$/) ){
        KclInfo.gBattle = data.api_data;
        KclInfo.gBattleStr = str;
        UpdateBattleLog();
        CalcBattleLog();

    }else if( url.match(/kcsapi\/api_req_battle_midnight\/battle$/) ){
        KclInfo.gBattle = data.api_data;
        KclInfo.gBattleStr = str;
        UpdateBattleLog();
        CalcMidnightBattleLog();

    }else if( url.match(/kcsapi\/api_req_practice\/battle$/) ){
        KclInfo.gBattle = data.api_data;
        if(!KclInfo.gMapRequest.api_enemy){
            KclInfo.gMapRequest.api_enemy=[];
        }
        KclInfo.gMapRequest.api_enemy.api_enemy_id="-";
        KclInfo.gBattleStr = str;

        UpdateSortieLog(GetDateTime() + bundle.getString("PRACTICE"))
        UpdateBattleLog();
        CalcBattleLog();

    }else if( url.match(/kcsapi\/api_req_practice\/midnight_battle$/) ){
        KclInfo.gBattle = data.api_data;
        KclInfo.gBattleStr = str;
        UpdateBattleLog();
        CalcMidnightBattleLog();

    }else if( url.match(/kcsapi\/api_req_battle_midnight\/sp_midnight$/) ){
        KclInfo.gBattle = data.api_data;
        KclInfo.gBattleStr = str;
        UpdateBattleLog();
        CalcMidnightBattleLog();

    }else if( url.match(/kcsapi\/api_req_sortie\/night_to_day$/) ){
        KclInfo.gBattle = data.api_data;
        KclInfo.gBattleStr = str;
        UpdateBattleLog();
        CalcNightToDayBattleLog();

    }else if( url.match(/kcsapi\/api_req_sortie\/battleresult$/) ){
        KclInfo.gBattleResult = data.api_data;
        UpdateBattleResultLog();

    }else if( url.match(/kcsapi\/api_get_master\/mapinfo$/) ){
        KclInfo.gMapInfo = data.api_data;

    }else if( url.match(/kcsapi\/api_get_master\/mapcell$/) ){
        KclInfo.gMapCell = data.api_data;

    }else if( url.match(/kcsapi\/api_get_member\/material$/) ){
        KclInfo.gMaterial = data.api_data;

    }
//}catch(e){
//    alert(e.message);
//}
}

function MaterialLog(){
    let msg = KclInfo.gMaterial[0].api_value + "/" 
            + KclInfo.gMaterial[1].api_value + "/" 
            + KclInfo.gMaterial[2].api_value + "/" 
            + KclInfo.gMaterial[3].api_value + ":[" 
            + KclInfo.gMaterial[5].api_value + "]" 
    UpdateSortieLog(GetDateTime() + msg);
}

function UpdateBattleResultLog(){
    let dispsortiebattleresult = hw_Branch.getBoolPref("dispsortiebattleresult");

    if(dispsortiebattleresult){
        let gmapID = GetDateTime() + bundle.getString("BATTLERESUT");
        let msg = KclInfo.gBattleResult.api_win_rank;
        if ( KclInfo.gBattleResult.api_get_flag[1] == 1 ){
            msg = msg + "(" + KclInfo.gBattleResult.api_get_ship.api_ship_name + ")";
        }
        if ( KclInfo.gBattleResult.api_get_eventflag == 1 ){
            msg = msg + "(" + KclInfo.gBattleResult.api_get_eventship.api_ship_name + ")";
        }
    UpdateSortieLog(gmapID + msg);
    }
}

function UpdateBattleLog(){
    let dispsortieenemyset = hw_Branch.getBoolPref("dispsortieenemyset");

    if(dispsortieenemyset){
        let gmapID = GetDateTime() + bundle.getString("ENEMYSET") + "[" + KclInfo.gMapRequest.api_enemy.api_enemy_id + "]";
        for (i in KclInfo.gBattle.api_ship_ke){
            if(KclInfo.gBattle.api_ship_ke[i]>0){
                gmapID=gmapID + "/" + SearchMasterShipByID(KclInfo.gBattle.api_ship_ke[i]).api_name + SearchMasterShipByID(KclInfo.gBattle.api_ship_ke[i]).api_yomi;
            }
        }
        UpdateSortieLog(gmapID);
    }
}

function UpdateMapInfoLog(){
    for (let i in KclInfo.gMapInfo){
        let icnt = parseInt(i);
        if((parseInt(KclInfo.gMapInfo[icnt].api_maparea_id) == parseInt(KclInfo.gMapRequest.api_maparea_id))
         &&(parseInt(KclInfo.gMapInfo[icnt].api_no) == parseInt(KclInfo.gMapRequest.api_mapinfo_no))){
            let msg = "[" + KclInfo.gMapInfo[icnt].api_maparea_id + "-" + KclInfo.gMapRequest.api_mapinfo_no + "]" + KclInfo.gMapInfo[icnt].api_name;
            let tkey = KclInfo.gMapInfo[icnt].api_eventmap;
            if (typeof tkey != "undefined"){
                msg = msg + "(" + tkey.api_now_maphp + "/" + tkey.api_max_maphp + ")";
            }
            tkey = KclInfo.gMapInfo[icnt].api_exboss;
            if (typeof tkey != "undefined"){
                msg = msg + "(" + tkey.api_defeat_count + "/" + tkey.api_required_defeat_count + ")";
            }
            UpdateSortieLog(GetDateTime() + msg);
            break;
        }
    }
}


function UpdateProgressLog(){
    let gEnemy = KclInfo.gMapRequest.api_enemy;
    let gHappen = KclInfo.gMapRequest.api_happening;
    let gItemGet = KclInfo.gMapRequest.api_itemget;
    let gmapID = GetDateTime() + KclInfo.gMapRequest.Direction 
               + KclInfo.gMapRequest.api_maparea_id + "-" 
               + KclInfo.gMapRequest.api_mapinfo_no + "-" 
               + KclInfo.gMapRequest.api_no + "("
               + KclInfo.gMapRequest.api_next + ")["
               + KclInfo.gMapRequest.api_event_id + "]";
    let msg = "";
    if ( typeof gEnemy !== "undefined"){
        if ( KclInfo.gMapRequest.api_event_id == 5) {
            msg = bundle.getString("ENEMYBOSS") + gEnemy.api_result_str + ":" + gEnemy.api_enemy_id;
        } else if( KclInfo.gMapRequest.api_event_id == 4 && KclInfo.gMapRequest.api_next==0){
            msg = bundle.getString("ENEMYOTHER") + gEnemy.api_result_str + ":" + gEnemy.api_enemy_id;
        } else {
            msg = bundle.getString("ENEMY") + gEnemy.api_result_str + ":" + gEnemy.api_enemy_id;
        }
    }else if( typeof gHappen !== "undefined"){
        msg = bundle.getString("HAPPENING") + bundle.getString("MATERIAL" + gHappen.api_mst_id) + ":" + gHappen.api_count;
    }else if( typeof gItemGet !== "undefined"){
        msg = bundle.getString("ITEMGET") + bundle.getString("MATERIAL" + gItemGet.api_id) + ":" + gItemGet.api_getcount;
    }
    UpdateSortieLog(gmapID + msg);
}

function GetDateTime(){

    let dispsortietime = hw_Branch.getBoolPref("dispsortietime");

    if(dispsortietime){
        let tDate= new Date();
        let tStr = tDate.getFullYear() + "/" + ("0" + (tDate.getMonth()+1)).slice(-2) + "/" + ( "0" + tDate.getDate()).slice(-2)
            tStr = ("0" + tDate.getHours()).slice(-2) + ":" + ("0" + tDate.getMinutes()).slice(-2) + ":" + ("0" + tDate.getSeconds()).slice(-2) + " ";
        return tStr;
    }else{
        return "";
    }
}

function UpdateSortieLog(str){
    let logbuf=42000;
    if(document.getElementById("sortielog").value.length > logbuf){
        document.getElementById("sortielog").value = document.getElementById("sortielog").value.slice(-(logbuf-4000));
    }
    if(document.getElementById("sortielog").value.length > 0){
        document.getElementById("sortielog").value =document.getElementById("sortielog").value + "\n" + str;
    }else{
        document.getElementById("sortielog").value = str;
    }
    document.getElementById("sortielog").inputField.scrollTop = document.getElementById("sortielog").inputField.scrollHeight


    let gLogFile = hw_Branch.getComplexValue("logfile",Components.interfaces.nsISupportsString).data;
    if(gLogFile !=""){
        writeToFile(gLogFile,str + "\r\n");
    }
}

function UpdateBaseInfo(){
    document.getElementById("shipcountvalue").value = "[" + KclInfo.gMemberShip.length + "/" + KclInfo.gMemberBasic.api_max_chara + "]";
    document.getElementById("equipmentcountvalue").value = "[" + KclInfo.gMemberItemList.length + "/" + KclInfo.gMemberBasic.api_max_slotitem + "]";
}

function UpdateStatusBarMode(){
    let StBM = StatusBarMode;

    let dispexped = hw_Branch.getBoolPref("dispexped");
    let dispndock = hw_Branch.getBoolPref("dispndock");
    let dispkdock = hw_Branch.getBoolPref("dispkdock");

    StBM++;
    StBM = StBM % 3;
    if(StBM == 0){
        if(dispexped){
        }else{
            if(dispndock){
                StBM=1;
            }else if(dispkdock){
                StBM=2;
            }else{
                StBM=3;
            }
        }
    }else if(StBM==1){
        if(dispndock){
        }else{
            if(dispkdock){
                StBM=2;
            }else if(dispexped){
                StBM=0;
            }else{
                StBM=3;
            }
        }
    }else if(StBM==2){
        if(dispkdock){
        }else{
            if(dispexped){
                StBM=0;
            }else if(dispndock){
                StBM=1;
            }else{
                StBM=3;
            }
        }
    }else{
        StBM=3;
    }
    StatusBarMode=StBM;
    clearInterval(StatusBarTimer2);
    StatusBarTimer2= setInterval(function(){UpdateStatusBarMode();},5000)
}

function UpdateStatusBar(){
    let dispkdockdetail = hw_Branch.getBoolPref("dispkdockdetail");

    let dt = new Date();
    let kdockdetail = "";
    document.getElementById("fleetstatus").label = "-";
    document.getElementById("fleet1comm").label = "-";
    document.getElementById("fleet2comm").label = "-";
    document.getElementById("fleet3comm").label = "-";
    document.getElementById("fleet4comm").label = "-";
    if(StatusBarMode == 0){
        document.getElementById("fleetstatus").label = bundle.getString("EXPEDITION");
        for( let i in KclInfo.gMemberFleet ){
            let icnt = parseInt(i);
            if(KclInfo.gMemberFleet[icnt].api_mission[0] == 1){
                let remaintime = KclInfo.gMemberFleet[icnt].api_mission[2] - dt.getTime();
                if(remaintime > 0){
                    let tHour = parseInt(remaintime / (60*60*1000));
                    let tMinute = ("0" + parseInt((remaintime % (60*60*1000))/(60*1000))).slice(-2);
                    let tSecond = ("0" + parseInt((remaintime % (60*1000))   /   (1000))).slice(-2);
                    document.getElementById("fleet"+(icnt+1)+"comm").label = tHour + ":" + tMinute + ":" + tSecond;
                }else{
                    document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("RETURNED");
                }
            }else{
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("WAITING");
            }
        }
    }else if(StatusBarMode == 1 ){
        document.getElementById("fleetstatus").label = bundle.getString("NDOCK");
        for( let i in KclInfo.gMemberNDock ){
            let icnt = parseInt(i);
            if(KclInfo.gMemberNDock[icnt].api_state == 1){
                let remaintime = KclInfo.gMemberNDock[icnt].api_complete_time - dt.getTime();
                if(remaintime > 0){
                    let tHour = parseInt(remaintime / (60*60*1000));
                    let tMinute = ("0" + parseInt((remaintime % (60*60*1000))/(60*1000))).slice(-2);
                    let tSecond = ("0" + parseInt((remaintime % (60*1000))   /   (1000))).slice(-2);
                    document.getElementById("fleet"+(icnt+1)+"comm").label = tHour + ":" + tMinute + ":" + tSecond;
                }else{
                    document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("COMPLETED");
                }
            }else if(KclInfo.gMemberNDock[icnt].api_state == 0){
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("NOUSE");
            }else{
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("CLOSED");
            }
        }
    }else if(StatusBarMode == 2 ){
        document.getElementById("fleetstatus").label = bundle.getString("KDOCK");
        for( let i in KclInfo.gMemberKDock ){
            let icnt = parseInt(i);
            if(dispkdockdetail && (KclInfo.gMemberKDock[icnt].api_created_ship_id>0)){
                kdockdetail = " - " + SearchMasterShipByID(KclInfo.gMemberKDock[icnt].api_created_ship_id).api_name;
            }else{
                kdockdetail = "";
            }
            if(KclInfo.gMemberKDock[icnt].api_state == 2){
                let remaintime = KclInfo.gMemberKDock[icnt].api_complete_time - dt.getTime();
                if(remaintime > 0){
                    let tHour = parseInt(remaintime / (60*60*1000));
                    let tMinute = ("0" + parseInt((remaintime % (60*60*1000))/(60*1000))).slice(-2);
                    let tSecond = ("0" + parseInt((remaintime % (60*1000))   /   (1000))).slice(-2);
                    document.getElementById("fleet"+(icnt+1)+"comm").label = tHour + ":" + tMinute + ":" + tSecond + kdockdetail;
                }else{
                    document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("KCOMPLETED") + kdockdetail;
                }
            }else if(KclInfo.gMemberKDock[icnt].api_state == 0){
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("NOUSE");
            }else if(KclInfo.gMemberKDock[icnt].api_state == 3){
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("KCOMPLETED") + kdockdetail;
            }else{
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("CLOSED");
            }
        }

    }else{
    document.getElementById("fleetstatus").label = "-";
    document.getElementById("fleet1comm").label = "-";
    document.getElementById("fleet2comm").label = "-";
    document.getElementById("fleet3comm").label = "-";
    document.getElementById("fleet4comm").label = "-";
    };
}

function UpdateFleetList(){
    for( let i in KclInfo.gMemberFleet ){
        icnt = parseInt(i);
        for( let j in KclInfo.gMemberFleet[icnt].api_ship){
            jcnt = parseInt(j);
            let mShip = KclInfo.gMemberFleet[icnt].api_ship[jcnt];
            if(mShip > 0){
                let memShip = SearchMemberShip(mShip);
                let msShip = SearchMasterShip(mShip);
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"cond").value = memShip.api_cond;
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"name").value = msShip.api_name;

                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup1").value = "[" + memShip.api_kyouka[0] + "/" + (parseInt(msShip.api_houg[1]) - parseInt(msShip.api_houg[0])) + "]"
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup2").value = "[" + memShip.api_kyouka[1] + "/" + (parseInt(msShip.api_raig[1]) - parseInt(msShip.api_raig[0])) + "]"
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup3").value = "[" + memShip.api_kyouka[2] + "/" + (parseInt(msShip.api_tyku[1]) - parseInt(msShip.api_tyku[0])) + "]"
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup4").value = "[" + memShip.api_kyouka[3] + "/" + (parseInt(msShip.api_souk[1]) - parseInt(msShip.api_souk[0])) + "]"
                if ((memShip.api_fuel != msShip.api_fuel_max) || (memShip.api_bull != msShip.api_bull_max)){
                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"supply").value = "*";
                }else{
                    document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"supply").value = "";
                }
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"hp").value = "[" + memShip.api_nowhp + "/" + memShip.api_maxhp + "]";

            }else{
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"cond").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"name").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup1").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup2").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup3").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup4").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"hp").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"supply").value = ""
            }
        }
    }

}

var gQuestTreeList =[];
var gQuestTreeView=null;

function UpdateQuestList(){
    gQuestTreeList.length= KclInfo.gQuestList.api_count;
    for(i=0;i<KclInfo.gQuestList.api_count;i++){
        if(typeof gQuestTreeList[i] === "undefined"){
            gQuestTreeList[i]={api_no:'*',api_title:'*',api_detail:'*',api_progress_flag:'*',api_state:'*'};
        }
    }

    if(KclInfo.gQuestList.api_record){
        for(let i in gQuestTreeList){
            if(gQuestTreeList[i].api_title.slice(0,1) != "*"){
                gQuestTreeList[i].api_title = "*" + gQuestTreeList[i].api_title;
            }
        }
    }
    for(let i in KclInfo.gQuestList.api_list){
        let icnt = parseInt(i);
        let jcnt = parseInt(KclInfo.gQuestList.api_disp_page)-1;
        if(typeof KclInfo.gQuestList.api_list[i].api_title !== "undefined"){
            gQuestTreeList[jcnt*5+icnt]=KclInfo.gQuestList.api_list[i];
        }
    }

}

function initQuestTree(){
    gQuestTreeView = new QuestTreeView(gQuestTreeList);
    document.getElementById("QuestTree").view = gQuestTreeView;
}

function QuestTreeView(aData) {
    this._data = aData;
}

QuestTreeView.prototype = {
    _treeBoxObject: null,
    get rowCount() {
        return this._data.length;
    },
    selection: null,
    getRowProperties: function(index, properties) {},
    getCellProperties: function(row, col, properties) {},
    getColumnProperties: function(col, properties) {},
    isContainer: function(index) { return false; },
    isContainerOpen: function(index) { return false; },
    isContainerEmpty: function(index) { return false; },
    isSeparator: function(index) {
        return this._data[index] == null;
    },
    isSorted: function() { return false; },
    canDrop: function(targetIndex, orientation, dataTransfer) { return false; },
    drop: function(targetIndex, orientation, dataTransfer) {},
    getParentIndex: function(rowIndex) { return -1; },
    hasNextSibling: function(rowIndex, afterIndex) { return false; },
    getLevel: function(index) { return 0; },
    getImageSrc: function(row, col) {},
    getProgressMode: function(row, col) {},
    getCellValue: function(row, col) {},
    getCellText: function(row, col) {
        switch (col.id) {
            case "quest.api_no" : return gQuestTreeList[row].api_no;
            case "quest.api_title" : return gQuestTreeList[row].api_title;
            case "quest.api_progress_flag" : 
                switch (gQuestTreeList[row].api_progress_flag){
                    case 1  : return bundle.getString("QUEST50");
                    case 2  : return bundle.getString("QUEST80");
                    default : return "";
                };
            case "quest.api_state" : 
                switch (gQuestTreeList[row].api_state){
                    case 1  : return bundle.getString("QUESTNONEXEC");
                    case 2  : return bundle.getString("QUESTEXEC");
                    case 3  : return bundle.getString("QUESTCOMP");
                    default : return "";
                }
            default : return 0;
        }
    },
    setTree: function(tree) {
        if (tree) {
            this._treeBoxObject = tree;
        }
        else {
            this._treeBoxObject = null;
            this._data = null;
        }
    },
    toggleOpenState: function(index) {},
    cycleHeader: function(col) {},
    selectionChanged: function() {},
    cycleCell: function(row, col) {},
    isEditable: function(row, col) { return false; },
    isSelectable: function(row, col) {},
    setCellValue: function(row, col, value) {},
    setCellText: function(row, col, value) {},
    performAction: function(action) {},
    performActionOnRow: function(action, row) {},
    performActionOnCell: function(action, row, col) {},
};

function QuestDetailContext(tObjs){
    tObjs.value = gQuestTreeList[(document.getElementById("QuestTree")).currentIndex].api_detail + "\n" 
                + gQuestTreeList[(document.getElementById("QuestTree")).currentIndex].api_get_material.join("/");
}

function SearchMemberShip( member_ship_id ){
    try{
        for( let cnt in KclInfo.gMemberShip ){
            let ship = KclInfo.gMemberShip[cnt];
            let id = ship.api_id;
            if( id==member_ship_id ){
                return ship;
            }
        }
    } catch (err) {
    }
    return "";
}

function SearchMasterShip( member_ship_id ){
    let shipid;
    try{
        for( let cnt in KclInfo.gMemberShip ){
            let ship = KclInfo.gMemberShip[cnt];
            let id = ship.api_id;
            shipid = ship.api_ship_id;
            if( id == member_ship_id ) break;
        }
        for( let cnt in KclInfo.gMasterShip ){
            let ship = KclInfo.gMasterShip[cnt];
            if( ship.api_id == shipid ){
                return ship;
            }
        }
    } catch (err) {
    }
    return "";
}

function SearchMasterShipByID( master_ship_id ){
    try{
        for( let cnt in KclInfo.gMasterShip ){
            let ship = KclInfo.gMasterShip[cnt];
            if( ship.api_id==master_ship_id ){
                return ship;
            }
        }
    } catch (err) {
    }
    return "";
}

function SearchMemberItem( item_id ){
    if(item_id<=0){return""};
    try{
        for( let cnt in KclInfo.gMemberItemList ){
            if( KclInfo.gMemberItemList[cnt].api_id==item_id ){
                return KclInfo.gMemberItemList[cnt];
            }
        }
    } catch (err) {
    }
    return "";
}


function CopyToClipboard(str){
    if(str.length<=0) return;
    let gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].  
    getService(Components.interfaces.nsIClipboardHelper);  
    gClipboardHelper.copyString(str);
}

var gShipTreeView = null;
var gShipTreeList = [];

function initShipTree(){
    let tree = document.getElementById("ShipTree")
    let fIdx = tree.treeBoxObject.getFirstVisibleRow();
    gShipTreeList = [];
    for (let i in KclInfo.gMemberShip){
        msShip=SearchMasterShip(KclInfo.gMemberShip[i].api_id);
        let nAry = [
            KclInfo.gMemberShip[i].api_id,
            msShip.api_name,
            msShip.api_stype,
            KclInfo.gMemberShip[i].api_lv,
            KclInfo.gMemberShip[i].api_cond,
            msShip.api_houg[1]-msShip.api_houg[0]-KclInfo.gMemberShip[i].api_kyouka[0],
            msShip.api_raig[1]-msShip.api_raig[0]-KclInfo.gMemberShip[i].api_kyouka[1],
            msShip.api_tyku[1]-msShip.api_tyku[0]-KclInfo.gMemberShip[i].api_kyouka[2],
            msShip.api_souk[1]-msShip.api_souk[0]-KclInfo.gMemberShip[i].api_kyouka[3],
            KclInfo.gMemberShip[i].api_ndock_time,
            i
            ]
        gShipTreeList.push(nAry);
    }
    gShipTreeView = new ShipTreeView(KclInfo.gMemberShip);

    for (let i in tree.columns){
//        document.getElementById("ShipTree").columns.getColumnAt(i).element.setAttribute("sortDirection","natural");

        sOrder = tree.columns.getColumnAt(i).element.getAttribute("sortDirection");
        let odr = 0;
        if ( sOrder == "ascending" ) {
            odr = 1;
            gShipTreeList.sort(
                function(a,b){
                    return (a[i]-b[i])*odr;
                }
            );

        } else if( sOrder == "descending" ) {
            odr = -1;
            gShipTreeList.sort(
                function(a,b){
                    return (a[i]-b[i])*odr;
                }
            );

        };

    }


    tree.view = gShipTreeView;

    tree.treeBoxObject.scrollToRow(fIdx);
    tree.treeBoxObject.invalidate();

}

function destroyShipTree(){
    document.getElementById("ShipTree").view = null;
}

function ShipTreeView(aData) {
    this._data = aData;
}

ShipTreeView.prototype = {
    _treeBoxObject: null,
    get rowCount() {
        return this._data.length;
    },
    selection: null,
    getRowProperties: function(index, properties) {
        let rflt=this._data[gShipTreeList[index][10]].api_id;
        let aserv=Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);

        for(let i in KclInfo.gMemberFleet){
            if( KclInfo.gMemberFleet[i].api_mission[0] == 1){
                for(let j in KclInfo.gMemberFleet[i].api_ship){
                    if(KclInfo.gMemberFleet[i].api_ship[j]== rflt)
                    {
                        if(typeof properties === "undefined"){
                            return aserv.getAtom("fleets");
                        }else{
                            properties.AppendElement(aserv.getAtom("fleets"));
                        return properties;
                        }
                    }
                }
            }
        }
        let memShip=SearchMemberShip(rflt);
        let msShip=SearchMasterShip(rflt);
        if ((memShip.api_fuel != msShip.api_fuel_max) || (memShip.api_bull != msShip.api_bull_max)){
            if(typeof properties === "undefined"){
                return aserv.getAtom("supply");
            }else{
                properties.AppendElement(aserv.getAtom("supply"));
            return properties;
            }
        }
        return properties;
    },
    getCellProperties: function(row, col, properties) {},
    getColumnProperties: function(col, properties) {},
    isContainer: function(index) { return false; },
    isContainerOpen: function(index) { return false; },
    isContainerEmpty: function(index) { return false; },
    isSeparator: function(index) {
        return this._data[index] == null;
    },
    isSorted: function() { return false; },
    canDrop: function(targetIndex, orientation, dataTransfer) { return false; },
    drop: function(targetIndex, orientation, dataTransfer) {},
    getParentIndex: function(rowIndex) { return -1; },
    hasNextSibling: function(rowIndex, afterIndex) { return false; },
    getLevel: function(index) { return 0; },
    getImageSrc: function(row, col) {},
    getProgressMode: function(row, col) {},
    getCellValue: function(row, col) {},
    getCellText: function(row, col) {
        let msShip = SearchMasterShip(this._data[gShipTreeList[row][10]].api_id);
        let memShip = SearchMemberShip(this._data[gShipTreeList[row][10]].api_id);
        switch (col.id) {
            case "api_id" : return parseInt(memShip.api_id);
            case "api_name" : return msShip.api_name;
            case "api_stype" : return msShip.api_stype;
            case "api_lv" : return parseInt(memShip.api_lv);
            case "api_cond" : return parseInt(memShip.api_cond);
            case "api_kyouka1" : return (parseInt(msShip.api_houg[1]) - 
                                         parseInt(msShip.api_houg[0])) - 
                                         parseInt(memShip.api_kyouka[0]);
            case "api_kyouka2" : return (parseInt(msShip.api_raig[1]) - parseInt(msShip.api_raig[0])) - parseInt(memShip.api_kyouka[1]);
            case "api_kyouka3" : return (parseInt(msShip.api_tyku[1]) - parseInt(msShip.api_tyku[0])) - parseInt(memShip.api_kyouka[2]);
            case "api_kyouka4" : return (parseInt(msShip.api_souk[1]) - parseInt(msShip.api_souk[0])) - parseInt(memShip.api_kyouka[3]);
            case "api_ndock_time" : let rtime=memShip.api_ndock_time;
                                    if(rtime==0){
                                        return "";
                                    }else{
                                        rtime = parseInt(rtime / 1000);
                                        let rsec= rtime % 60;
                                        rtime = (rtime - rsec)/60;
                                        let rmin= rtime %60;
                                        rtime = (rtime - rmin)/60;
                                        return ("00"+rtime).slice(-2) + ":" + ("00"+rmin).slice(-2) + ":" + ("00"+rsec).slice(-2);
                                    }
            default : return 0;
        }
    },
    setTree: function(tree) {
        if (tree) {
            this._treeBoxObject = tree;
        }
        else {
            this._treeBoxObject = null;
            this._data = null;
        }
    },
    toggleOpenState: function(index) {},
    cycleHeader: function(col) {
        let sOrder=col.element.getAttribute("sortDirection");
        for (let i in col.columns){
            col.columns.getColumnAt(i).element.setAttribute("sortDirection","natural");
        };
        let odr = 0;
        if ( sOrder == "ascending" ) {
            odr = -1;
            sOrder = "descending" ;
        } else {
            odr = 1;
            sOrder = "ascending"  ;
        };
        gShipTreeList.sort(
            function(a,b){
                return (a[col.index]-b[col.index])*odr;
            }
        );
        col.element.setAttribute("sortDirection",sOrder);
        this._treeBoxObject.invalidate();
    },
    selectionChanged: function() {},
    cycleCell: function(row, col) {
    },
    isEditable: function(row, col) { return false; },
    isSelectable: function(row, col) {},
    setCellValue: function(row, col, value) {},
    setCellText: function(row, col, value) {},
    performAction: function(action) {},
    performActionOnRow: function(action, row) {},
    performActionOnCell: function(action, row, col) {},
};

var gItemEquipList = [];
var gItemList = [];

function UpdateItemEquipList(){
    gItemEquipList = [];
    for ( let i in KclInfo.gMemberShip){
        if ( KclInfo.gMemberShip[i].api_slot[0] > 0){
            gItemEquipList[parseInt(KclInfo.gMemberShip[i].api_slot[0])]=i;
        }
        if ( KclInfo.gMemberShip[i].api_slot[1] > 0){
            gItemEquipList[parseInt(KclInfo.gMemberShip[i].api_slot[1])]=i;
        }
        if ( KclInfo.gMemberShip[i].api_slot[2] > 0){
            gItemEquipList[parseInt(KclInfo.gMemberShip[i].api_slot[2])]=i;
        }
        if ( KclInfo.gMemberShip[i].api_slot[3] > 0){
            gItemEquipList[parseInt(KclInfo.gMemberShip[i].api_slot[3])]=i;
        }
    }
}

function UpdateItemList(){
    gItemList=[];
    let ItemEquipCount=0;
    for ( let i in KclInfo.gMemberItemList){
        let ItemID = KclInfo.gMemberItemList[i].api_name;
        let ItemEquipID=gItemEquipList[parseInt(KclInfo.gMemberItemList[i].api_id)];
        if ( typeof ItemEquipID === "undefined"){
            ItemEquipCount = 0;
            ItemEquipID="";
        }else{
            ItemEquipCount = 1;
        }
        let ItemListID = gItemList[ItemID];
        if ( typeof ItemListID === "undefined"){
            gItemList[ItemID] = [KclInfo.gMemberItemList[i].api_slotitem_id,ItemID,0,0,""];
        }
        gItemList[ItemID][3] = gItemList[ItemID][3] + 1;
        gItemList[ItemID][2] = parseInt(gItemList[ItemID][2]) + parseInt(ItemEquipCount);
        gItemList[ItemID][4] = gItemList[ItemID][4] + "," + ItemEquipID;
    }
    let reList=[];
    for (let j in gItemList){
       let nAry = [
           gItemList[j][0],
           gItemList[j][1],
           gItemList[j][2],
           gItemList[j][3],
           gItemList[j][4]
           ]
       reList.push(nAry);
    }
    gItemList = [];
    gItemList = reList;
}

function EquipedShipsList(tObjs){
    let eList="";
    tObjs.value="testupdate." + (document.getElementById("ItemTree")).currentIndex;
    let tItem = (document.getElementById("ItemTree")).currentIndex;
    tItem = gItemList[tItem][4].split(",");
    tItem.sort();
    for(let i in tItem){
        let tShip=KclInfo.gMemberShip[tItem[i]];
        if ( typeof tShip !== "undefined"){
            eList= eList + "\n"+tShip.api_id + ":" + SearchMasterShip(tShip.api_id).api_name + "(Lv" + tShip.api_lv + ")";
        }
    }
    tObjs.value=eList.trim();
}

function ShipDetailContext(tObjs,event){
    let fleet=parseInt(tObjs.slice(5,6))-1;
    let shipid=parseInt(tObjs.slice(10,11))-1;
    if(KclInfo.gMemberFleet[fleet].api_ship[shipid] != -1){
        let memShip=SearchMemberShip(KclInfo.gMemberFleet[fleet].api_ship[shipid]);
        let msShip=SearchMasterShip(KclInfo.gMemberFleet[fleet].api_ship[shipid]);
        document.getElementById("shipdetailname").value=msShip.api_name;
        document.getElementById("shipdetaillv").value=memShip.api_lv;
        document.getElementById("shipdetailstatus").value="["+memShip.api_nowhp+"/"+memShip.api_maxhp+"]";
        if(memShip.api_slot[0] != -1){
            document.getElementById("shipdetailequip1").value=SearchMemberItem(memShip.api_slot[0]).api_name;
        }else{
            document.getElementById("shipdetailequip1").value="";
        }
        if(memShip.api_slot[1] != -1){
            document.getElementById("shipdetailequip2").value=SearchMemberItem(memShip.api_slot[1]).api_name;
        }else{
            document.getElementById("shipdetailequip2").value="";
        }
        if(memShip.api_slot[2] != -1){
            document.getElementById("shipdetailequip3").value=SearchMemberItem(memShip.api_slot[2]).api_name;
        }else{
            document.getElementById("shipdetailequip3").value="";
        }
        if(memShip.api_slot[3] != -1){
            document.getElementById("shipdetailequip4").value=SearchMemberItem(memShip.api_slot[3]).api_name;
        }else{
            document.getElementById("shipdetailequip4").value="";
        }
        if(memShip.api_slot[4] != -1){
            document.getElementById("shipdetailequip5").value=SearchMemberItem(memShip.api_slot[4]).api_name;
        }else{
            document.getElementById("shipdetailequip5").value="";
        }
    }else{
        event.preventDefault();
    }
}


var gItemTreeView = null;

function initItemTree(){
    gItemTreeView = new ItemTreeView(gItemList);
    for (let i in document.getElementById("ItemTree").columns){
        document.getElementById("ItemTree").columns.getColumnAt(i).element.setAttribute("sortDirection","natural");
    }
    document.getElementById("ItemTree").view = gItemTreeView;
}

function destroyItemTree(){
    document.getElementById("ItemTree").view = null;
}

function ItemTreeView(aData) {
    this._data = aData;
}

ItemTreeView.prototype = {
    _treeBoxObject: null,
    get rowCount() {
        return this._data.length;
    },
    selection: null,
    getRowProperties: function(index, properties) {},
    getCellProperties: function(row, col, properties) {},
    getColumnProperties: function(col, properties) {},
    isContainer: function(index) { return false; },
    isContainerOpen: function(index) { return false; },
    isContainerEmpty: function(index) { return false; },
    isSeparator: function(index) {
        return this._data[index] == null;
    },
    isSorted: function() { return false; },
    canDrop: function(targetIndex, orientation, dataTransfer) { return false; },
    drop: function(targetIndex, orientation, dataTransfer) {},
    getParentIndex: function(rowIndex) { return -1; },
    hasNextSibling: function(rowIndex, afterIndex) { return false; },
    getLevel: function(index) { return 0; },
    getImageSrc: function(row, col) {},
    getProgressMode: function(row, col) {},
    getCellValue: function(row, col) {},
    getCellText: function(row, col) {
        switch (col.index) {
            case 0 : return gItemList[row][0];
            case 1 : return gItemList[row][1];
            case 2 : return gItemList[row][2];
            case 3 : return gItemList[row][3];
            default : return 0;
        }
    },
    setTree: function(tree) {
        if (tree) {
            this._treeBoxObject = tree;
        }
        else {
            this._treeBoxObject = null;
            this._data = null;
        }
    },
    toggleOpenState: function(index) {},
    cycleHeader: function(col) {
        let sOrder=col.element.getAttribute("sortDirection");
        for (let i in col.columns){
            col.columns.getColumnAt(i).element.setAttribute("sortDirection","natural");
        };
        let odr = 0;
        if ( sOrder == "ascending" ) {
            odr = -1;
            sOrder = "descending" ;
        } else {
            odr = 1;
            sOrder = "ascending"  ;
        };
        gItemList.sort(
            function(a,b){
                return (a[col.index]-b[col.index])*odr;
            }
        );
        col.element.setAttribute("sortDirection",sOrder);
        this._treeBoxObject.invalidate();
    },
    selectionChanged: function() {},
    cycleCell: function(row, col) {
    },
    isEditable: function(row, col) { return false; },
    isSelectable: function(row, col) {},
    setCellValue: function(row, col, value) {},
    setCellText: function(row, col, value) {},
    performAction: function(action) {},
    performActionOnRow: function(action, row) {},
    performActionOnCell: function(action, row, col) {},
};

function DeleteSortieLog(){
    document.getElementById("sortielog").value ="";
}

function CalcBattleLog(){

    let dispsortiecalcbattle = hw_Branch.getBoolPref("dispsortiecalcbattle");
    if (dispsortiecalcbattle == false){
        return "";
    }

//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];

//api_stage_flag
    if(KclInfo.gBattle.api_stage_flag[2] == 1){
        let fdam = KclInfo.gBattle.api_kouku.api_stage3.api_fdam;
        for(let i in fdam){
            let icnt = parseInt(i);
            if(fdam[icnt] != -1){
                dmghps[icnt] = dmghps[icnt] + parseInt(fdam[icnt]);
            }
        }
        let edam = KclInfo.gBattle.api_kouku.api_stage3.api_edam;
        for(let i in edam){
            let icnt = parseInt(i);
            if(edam[icnt] != -1){
                dmghps[icnt+6] = dmghps[icnt+6] + parseInt(edam[icnt]);
            }
        }

    }

    dmghps=CalcSupportAttack(dmghps,KclInfo.gBattle.api_support_flag,KclInfo.gBattle.api_support_info);

//api_opening_flag
    if(KclInfo.gBattle.api_opening_flag == 1){
        dmghps=CalcOpeningAttack(dmghps,KclInfo.gBattle.api_opening_atack);
    }
//api_hourai
    dmghps=CalcHouraiAttack(dmghps,
                            KclInfo.gBattle.api_hourai_flag,
                            KclInfo.gBattle.api_hougeki1,
                            KclInfo.gBattle.api_hougeki2,
                            KclInfo.gBattle.api_hougeki3,
                            KclInfo.gBattle.api_raigeki);

    dmshps=CalcBattleResultLog(dmghps,nowhps,maxhps);
    return "";
}


function CalcMidnightBattleLog(){

    let dispsortiecalcbattle = hw_Branch.getBoolPref("dispsortiecalcbattle");
    if (dispsortiecalcbattle == false){
        return "";
    }

//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];

//api_hourai_flag[0]
    CalcNightAttack(dmghps,KclInfo.gBattle.api_hougeki);
    dmshps = CalcBattleResultLog(dmghps,nowhps,maxhps);
    return dmghps;
}


function CalcNightToDayBattleLog(){

    let dispsortiecalcbattle = hw_Branch.getBoolPref("dispsortiecalcbattle");
    if (dispsortiecalcbattle == false){
        return "";
    }

//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];

//NightMode
    CalcNightAttack(dmghps,KclInfo.gBattle.api_hougeki);

//dayFlag
    if(KclInfo.gBattle.api_day_flag == 1){

    //api_stage_flag
        if(KclInfo.gBattle.api_stage_flag[2] == 1){
            let fdam = KclInfo.gBattle.api_kouku.api_stage3.api_fdam;
            for(let i in fdam){
                let icnt = parseInt(i);
                if(fdam[icnt] != -1){
                    dmghps[icnt] = dmghps[icnt] + parseInt(fdam[icnt]);
                }
            }
            let edam = KclInfo.gBattle.api_kouku.api_stage3.api_edam;
            for(let i in edam){
                let icnt = parseInt(i);
                if(edam[icnt] != -1){
                    dmghps[icnt+6] = dmghps[icnt+6] + parseInt(edam[icnt]);
                }
            }

        }

    //api_support_flag
    dmghps=CalcSupportAttack(dmghps,KclInfo.gBattle.api_support_flag,KclInfo.gBattle.api_support_info);

    //api_opening_flag
        if(KclInfo.gBattle.api_opening_flag == 1){
            dmghps=CalcOpeningAttack(dmghps,KclInfo.gBattle.api_opening_atack);
        }
    //api_hourai
        dmghps=CalcHouraiAttack(dmghps,
                            KclInfo.gBattle.api_hourai_flag,
                            KclInfo.gBattle.api_hougeki1,
                            KclInfo.gBattle.api_hougeki2,
                            KclInfo.gBattle.api_hougeki3,
                            KclInfo.gBattle.api_raigeki);

    }
    dmshps = CalcBattleResultLog(dmghps,nowhps,maxhps);
    return "";
}

function CalcSupportAttack(dmghps,tFlags,tObjs){
    if(tFlags==1){
    UpdateSortieLog(GetDateTime() + bundle.getString("AIRSUPPORT"));
        for(let i=1; i<7; i++){
            if(tObjs.api_support_airatack.api_stage3[i]>0){
                dmghps[i+6]=dmghps[i+6]+tObjs.api_support_airatack.api_stage3[i];
            }
        }
    }else if(tFlags==2){
    UpdateSortieLog(GetDateTime() + bundle.getString("HOURAISUPPORT"));
        for(let i=1; i<7; i++){
            if(tObjs.api_support_hourai.api_damage[i]>0){
                dmghps[i+6]=dmghps[i+6]+tObjs.api_support_hourai.api_damage[i];
            }
        }
    }
    return dmghps;
}

function CalcNightAttack(dmghps,tObjs){
    for (let i in tObjs.api_df_list){
        let icnt = parseInt(i);
        if (tObjs.api_df_list[icnt] instanceof Array){
            for ( let k in tObjs.api_df_list[icnt]){
                kcnt = parseInt(k);
                let j=parseInt(tObjs.api_df_list[icnt][kcnt]);
                if(tObjs.api_damage[icnt][kcnt] != -1){
                    dmghps[j]=dmghps[j] + parseInt(tObjs.api_damage[icnt][kcnt]);
                }
            }
        }
    }
    return dmghps;
}

function CalcHouraiAttack(dmghps,tFlags,tObjs1,tObjs2,tObsj3,tObjs4){
    if(tFlags[0] == 1){
        for (let i in tObjs1.api_df_list){
            let icnt = parseInt(i);
            let j=parseInt(tObjs1.api_df_list[icnt]);
            if(tObjs1.api_damage[icnt] != -1){
                dmghps[j]=dmghps[j] + parseInt(tObjs1.api_damage[icnt]);
            }
        }
    }
    if(tFlags[1] == 1){
        for (let i in tObjs2.api_df_list){
            let icnt = parseInt(i);
            let j=parseInt(tObjs2.api_df_list[icnt]);
            if(tObjs2.api_damage[icnt] != -1){
                dmghps[j]=dmghps[j] + parseInt(tObjs2.api_damage[icnt]);
            }
        }
    }
    if(tFlags[3] == 1){
        for(let i in tObjs4.api_fdam){
            let icnt = parseInt(i);
            if(tObjs4.api_fdam[icnt] != -1){
                dmghps[icnt] = dmghps[icnt] + parseInt(tObjs4.api_fdam[icnt]);
            }
        }
        for(let i in tObjs4.api_edam){
            let icnt = parseInt(i);
            if(tObjs4.api_edam[icnt] != -1){
                dmghps[icnt+6] = dmghps[icnt+6] + parseInt(tObjs4.api_edam[icnt]);
            }
        }
    }
    return dmghps;
}

function CalcOpeningAttack(dmghps,tObjs){
    for(let i in tObjs.api_fdam){
        let icnt = parseInt(i);
        if(tObjs.api_fdam[icnt] != -1){
            dmghps[icnt] = dmghps[icnt] + parseInt(tObjs.api_fdam[icnt]);
        }
    }
    for(let i in tObjs.api_edam){
        let icnt = parseInt(i);
        if(tObjs.api_edam[icnt] != -1){
            dmghps[icnt+6] = dmghps[icnt+6] + parseInt(tObjs.api_edam[icnt]);
        }
    }
    return dmghps;
}

function CalcBattleResultLog(dmghps,nowhps,maxhps){
    let fMsg = bundle.getString("MYFLEET");
    let eMsg = bundle.getString("ENEMYFLEET");
    let fRatio=[0,0];
    let eRatio=[0,0];
    let dFlag="";
    let dList="";
//calculate
    for (let i=0; i<13; i++){
        dmghps[i]= nowhps[i]-dmghps[i];
        if (dmghps[i]<0){dmghps[i]=0}
    }
    for (let i=1; i<7; i++){
        if(maxhps[i] != -1){
            fMsg=fMsg + "[" + dmghps[i] + "/" + maxhps[i] + "]";
            fRatio[0]=fRatio[0]+dmghps[i];
            fRatio[1]=fRatio[1]+parseInt(nowhps[i]);
            let drt=dmghps[i]/maxhps[i];
            if(drt<=0.25){
                dFlag=bundle.getString("DMGHIGHRATIO");
            }else if((drt<=0.5)&&(dFlag=="")){
                dFlag=bundle.getString("DMGMIDRATIO");
            }
        }
    }
    for (let i=7; i<13; i++){
        if(maxhps[i] != -1){
            eMsg=eMsg + "[" + dmghps[i] + "/" + maxhps[i] + "]";
            eRatio[0]=eRatio[0]+dmghps[i];
            eRatio[1]=eRatio[1]+parseInt(nowhps[i]);
        }
    }
// output
    fMsg= (((fRatio[1]-fRatio[0])/fRatio[1])*100).toFixed(1) + "%:" + fMsg
    eMsg= (((eRatio[1]-eRatio[0])/eRatio[1])*100).toFixed(1) + "%:" + eMsg
    UpdateSortieLog(GetDateTime() + fMsg);
    UpdateSortieLog(GetDateTime() + eMsg);
    if(dFlag!=""){
        UpdateSortieLog(GetDateTime() + dFlag);
    }
    return dmghps;
}

function writeToFile (filename, content) {
    try{
        let gLogFile = filename;
        let tDate = new Date();
        gLogFile=gLogFile.replace(/\%YYYY\%/ig,tDate.getFullYear());
        gLogFile=gLogFile.replace(/\%MM\%/ig,( "0" + ( tDate.getMonth() + 1 ) ).slice(-2) );
        gLogFile=gLogFile.replace(/\%DD\%/ig,( "0" + ( tDate.getDate()) ).slice(-2) );

        let file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(gLogFile);
        if (! file.exists()){
            file.create(0, parseInt("0664",8));
        }
        let out = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
        out.init(file, 0x10 | 0x02, parseInt("0664",8), null);
        let charset = "UTF-8";
        let conv = Components.classes["\@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
        conv.init(out, charset, 0, 0x0000);
        conv.writeString(content);
        conv.close();
    }catch(e){
        throw e;
    }
}


window.addEventListener("load", function(e){ KclInsp.init(); }, false);
window.addEventListener("unload", function(e){ KclInsp.destroy(); }, false);
